subroutine FM34(Fun, Grad, X, Eps)
!   f(x1,x2,...,xn)
! -
interface
  real function Fun(x)
    real, intent(in):: X(:)
  end function Fun
  real function Grad(x, g)
    real, intent(in):: x(:)
    real:: g(:)
  end function Grad
end interface
real, intent(in):: Eps
real, intent(inout):: X(:)
integer, parameter:: Cmax=1000, Kmax=4
real, allocatable:: P(:), Q(:), D(:), G(:)
real Z, FP, FQ, FR, GP, GQ, GR, G0, G1, G2, G3, GK,  &
    QX, DD, HH, W, WW, ZZ, AK
real ME2, EE
integer Error
integer i, k, n, cc
!begin
    ! 
    ME2=epsilon(1.0)
    !  
    EE=Eps; if (EE<Eps) EE=Eps
    n=size(X); cc=0; Error=0
    allocate(P(n), Q(n), D(n), G(n))
400 continue
    !print *, '  The current values'
    !print 333, (i, X(i), i=1, N)
    do i=1,n; P(i)=X(i); enddo
    Z=Fun(X); FP=Z
    !print *, 'Iteration',cc,' Value of function',Z
    G0=Grad(X, G); GK=G0
    !    
    !  
    do i=1,n; D(i)=-G(i); enddo
    k=0
600 continue
    GP=0.0
    do i=1,n; GP=GP+G(i)*D(i); enddo
    if (abs(GP)<Eps) goto 1100
    !  
    QX=abs(2.0*FP/GP); if (QX>1.0) QX=1.0
    if (GP>0.0) then
        !    
        do i=1, N
            X(i)=P(i)-QX*D(i); P(i)=X(i)
        enddo
        Z=Fun(X); FP=Z !; print *, 'Possible instability?',' Value of function',Z
        G0=Grad(X, G); G1=G0
        k=k+1; if (k<2) goto 600
        !Abort
        Error=65; goto 1300
    endif
    HH=QX
700 continue
    !   Q
    do i=1, N
        Q(i)=P(i)+HH*D(i); X(i)=Q(i)
    enddo
    Z=Fun(X); FQ=Z
    G0=Grad(X, G); G2=G0
    GQ=0.0
    do i=1, N; GQ=GQ+G(i)*D(i); enddo
    if ((FP>FQ).and.(GQ<0.0)) then        ;print*,'    HH=',2.0*HH,' GP=',GP,' GQ=',GQ
        !   ,   
        !   
        !do i=1,n; P(i)=Q(i); enddo
        !FP=FQ; GP=GQ; G1=G2
        HH=2.0*HH; goto 700
    endif
    k=0;
860 continue
    ! 
    ZZ=3.0*(FP-FQ)/HH+GP+GQ
    WW=ZZ*ZZ-GP*GQ; if (WW<0.0) WW=0.0
    W=sqrt(WW)
    DD=HH*(1.0-(GQ+W-ZZ)/(GQ-GP+2.0*W))
    do i=1,n; X(i)=P(i)+DD*D(i); enddo
    Z=Fun(X); FR=Z
    G0=Grad(X, G); G3=G0
    if (abs(G3)<EE) goto 1300
    !    
    GR=0.0
    do i=1,n; GR=GR+G(i)*D(i); enddo;
        print 333, (i, X(i), i=1, N)
        print *, 'K=',k,' h=',HH,' fun=',FR,' grad=',G3
        print *, ' FP=',FP,' FQ=',FQ,' Z=FR=',FR
        print *, ' GP=',GP,' GQ=',GQ,' GR=',GR
    if ((Z<=FP).and.(Z<=FQ)) goto 1100
    !  
    !   HH-DD  DD
    if (GR<0.0) then
        HH=HH-DD
        do i=1,n; P(i)=X(i); enddo
        FP=Z; GP=GR; G1=G0
        k=k+1; if (k<Kmax) goto 860
    else
        HH=DD
        do i=1,n; Q(i)=X(i); enddo
        FQ=Z; GQ=GR; G2=G0
        k=k+1; if (k<Kmax) goto 860
    endif
    !Abort
    Error=66; goto 1300
1100 continue
    !  
    do i=1,n
        if(abs(X(i)+HH)==abs(X(i))) goto 1300
    enddo
    cc=cc+1
    if (cc==Cmax) goto 1300
    if (mod(cc,n)==0) goto 400
    !  
    AK=G3*G3/(GK*GK)
    do i=1,n
        D(i)=-G(i)+AK*D(i); P(i)=X(i)
    enddo
    FP=FR; G1=G0; GK=G0; goto 600
1300 continue
    ! 
    !print *, 'The minimum'
    !print 333, (i, X(i), i=1,n)
    !print *, 'The number of iterations =',cc,', value of function =',Z
    !print *, 'Error',Error
    deallocate(P, Q, D, G)
333 format(<n>(2X,'X[',I1,']=',F9.6))
end subroutine FM34
